Create a follower
- PUT /{index}/_ccr/follow
Create a cross-cluster replication follower index that follows a specific leader index. When the API returns, the follower index exists and cross-cluster replication starts replicating operations from the leader index to the follower index.
Required privileges
- Index privileges manage_follow_index
- Cluster privileges manage_ccr
Query parameters
-
master_timeoutunion oneOf · default: 30s -
Period to wait for a connection to the master node.
-
Values:
-10 -
wait_for_active_shardsunion oneOf · default: 0 -
Specifies the number of shards to wait on being active before responding. This defaults to waiting on none of the shards to be active. A shard must be restored from the leader index before being active. Restoring a follower shard requires transferring all the remote Lucene segment files to the follower index.
-
Values:
allindex-setting
Request body
-
data_stream_namestring -
If the leader index is part of a data stream, the name to which the local data stream for the followed index should be renamed.
-
max_outstanding_read_requestsnumber -
The maximum number of outstanding reads requests from the remote cluster.
-
max_outstanding_write_requestsnumber -
The maximum number of outstanding write requests on the follower.
-
max_read_request_operation_countnumber -
The maximum number of operations to pull per read from the remote cluster.
-
max_read_request_sizenumber | string -
The maximum size in bytes of per read of a batch of operations pulled from the remote cluster.
-
max_retry_delayunion oneOf -
The maximum time to wait before retrying an operation that failed exceptionally. An exponential backoff strategy is employed when retrying.
-
Values:
-10 -
max_write_buffer_countnumber -
The maximum number of operations that can be queued for writing. When this limit is reached, reads from the remote cluster will be deferred until the number of queued operations goes below the limit.
-
max_write_buffer_sizenumber | string -
The maximum total bytes of operations that can be queued for writing. When this limit is reached, reads from the remote cluster will be deferred until the total bytes of queued operations goes below the limit.
-
max_write_request_operation_countnumber -
The maximum number of operations per bulk write request executed on the follower.
-
max_write_request_sizenumber | string -
The maximum total bytes of operations per bulk write request executed on the follower.
-
read_poll_timeoutunion oneOf -
The maximum time to wait for new operations on the remote cluster when the follower index is synchronized with the leader index. When the timeout has elapsed, the poll for operations will return to the follower so that it can update some statistics. Then the follower will immediately attempt to read from the leader again.
-
Values:
-10 -
settingsobject -
Settings to override from the leader index.
-
indexobject -
Same fields as
settings -
soft_deletesobject -
retention_leaseobject -
The maximum period to retain a shard history retention lease before it is considered expired. Shard history retention leases ensure that soft deletes are retained during merges on the Lucene index. If a soft delete is merged away before it can be replicated to a follower the following process will fail due to incomplete history on the leader.
-
analyzeobject -
Settings to define analyzers, tokenizers, token filters and character filters. Refer to the linked documentation for step-by-step examples of updating analyzers on existing indices.
- Reference
-
routingobject -
allocationobject -
requireobject -
Assign the index to a node whose attribute has all of the given values. Each key is a node attribute: one of the built-in attributes
_name,_host_ip,_publish_ip,_ip,_host,_idand_tier, or a custom node attribute. Each value is a comma-separated string or an array of strings, and can use wildcards. -
lifecycleobject -
namestring -
The name of the policy to use to manage the index. For information about how Elasticsearch applies policy changes, see Policy updates.
-
indexing_completeboolean | string · default: false -
Indicates whether or not the index has been rolled over. Automatically set to true when ILM completes the rollover action. You can explicitly set it to skip rollover.
-
origination_datenumber · default: 0 -
If specified, this is the timestamp used to calculate the index age for its phase transitions. Use this setting if you create a new index that contains old data and want to use the original creation date to calculate the index age. Specified as a Unix epoch value in milliseconds.
-
parse_origination_dateboolean -
Set to true to parse the origination date from the index name. This origination date is used to calculate the index age for its phase transitions. The index name must match the pattern ^.*-{date_format}-\d+, where the date_format is yyyy.MM.dd and the trailing digits are optional. An index that was rolled over would normally match the full format, for example logs-2016.10.31-000002). If the index name doesn’t match the pattern, index creation fails.
-
translogobject -
sync_intervalunion oneOf · default: 5s -
How often the translog is fsynced to disk and committed, regardless of write operations. Values less than 100ms are not allowed.
-
Values:
-10 -
durabilityenum · default: string -
Whether or not to
fsyncand commit the translog after every index, delete, update, or bulk request.Supported values include:
request(orREQUEST): (default) fsync and commit after every request. In the event of hardware failure, all acknowledged writes will already have been committed to disk.async(orASYNC): fsync and commit in the background every sync_interval. In the event of a failure, all acknowledged writes since the last automatic commit will be discarded.
-
Values:
requestREQUESTasyncASYNC -
flush_threshold_sizenumber | string · default: 512mb -
The translog stores all operations that are not yet safely persisted in Lucene (i.e., are not part of a Lucene commit point). Although these operations are available for reads, they will need to be replayed if the shard was stopped and had to be recovered. This setting controls the maximum total size of these operations, to prevent recoveries from taking too long. Once the maximum size has been reached a flush will happen, generating a new Lucene commit point.
-
retentionobject -
sizenumber | string · default: 512mb -
This controls the total size of translog files to keep for each shard. Keeping more translog files increases the chance of performing an operation based sync when recovering a replica. If the translog files are not sufficient, replica recovery will fall back to a file based sync. This setting is ignored, and should not be set, if soft deletes are enabled. Soft deletes are enabled by default in indices created in Elasticsearch versions 7.0.0 and later.
-
ageunion oneOf · default: 12h -
This controls the maximum duration for which translog files are kept by each shard. Keeping more translog files increases the chance of performing an operation based sync when recovering replicas. If the translog files are not sufficient, replica recovery will fall back to a file based sync. This setting is ignored, and should not be set, if soft deletes are enabled. Soft deletes are enabled by default in indices created in Elasticsearch versions 7.0.0 and later.
-
Values:
-10 -
analysisobject -
analyzermap string to oneOf -
<string>union oneOf -
max_output_sizenumber · default: 255 -
The maximum token size to emit. Tokens larger than this size will be discarded. Defaults to
255 -
stopwordsunion oneOf · default: _none_ -
A pre-defined stop words list like
_english_or an array containing a list of stop words. Defaults to_none_. -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
flagsstring -
Java regular expression flags. Flags should be pipe-separated, eg "CASE_INSENSITIVE|COMMENTS".
-
stopwordsunion oneOf · default: _none_ -
A pre-defined stop words list like
_english_or an array containing a list of stop words. Defaults to_none_. -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
max_token_lengthnumber · default: 255 -
The maximum token length. If a token is seen that exceeds this length then it is split at
max_token_lengthintervals. Defaults to255. -
stopwordsunion oneOf · default: _none_ -
A pre-defined stop words list like
_english_or an array containing a list of stop words. Defaults to_none_. -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf · default: _none_ -
A pre-defined stop words list like
_english_or an array containing a list of stop words. Defaults to_none_. -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
languageenumrequired -
Values:
ArabicArmenianBasqueCatalanDanishDutchEnglishEstonianFinnishFrenchGermanGerman2HungarianItalianIrishKpLithuanianLovinsNorwegianPorterPortugueseRomanianRussianSerbianSpanishSwedishTurkish -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
char_filtermap string to oneOf -
<string>union oneOf -
filtermap string to oneOf -
<string>union oneOf -
common_wordsstring[] -
A list of tokens. The filter generates bigrams for these tokens. Either this or the
common_words_pathparameter is required. -
common_words_pathstring -
Path to a file containing a list of tokens. The filter generates bigrams for these tokens. This path must be absolute or relative to the
configlocation. The file must be UTF-8 encoded. Each token in the file must be separated by a line break. Either this or thecommon_wordsparameter is required. -
articlesstring[] -
List of elisions to remove. To be removed, the elision must be at the beginning of a token and be immediately followed by an apostrophe. Both the elision and apostrophe are removed. For custom
elisionfilters, either this parameter orarticles_pathmust be specified. -
articles_pathstring -
Path to a file that contains a list of elisions to remove. This path must be absolute or relative to the
configlocation, and the file must be UTF-8 encoded. Each elision in the file must be separated by a line break. To be removed, the elision must be at the beginning of a token and be immediately followed by an apostrophe. Both the elision and apostrophe are removed. For customelisionfilters, either this parameter orarticlesmust be specified. -
max_subword_sizenumber -
Maximum subword character length. Longer subword tokens are excluded from the output. Defaults to
15. -
min_subword_sizenumber -
Minimum subword character length. Shorter subword tokens are excluded from the output. Defaults to
2. -
min_word_sizenumber -
Minimum word character length. Shorter word tokens are excluded from the output. Defaults to
5. -
word_liststring[] -
A list of subwords to look for in the token stream. If found, the subword is included in the token output. Either this parameter or
word_list_pathmust be specified. -
word_list_pathstring -
Path to a file that contains a list of subwords to find in the token stream. If found, the subword is included in the token output. This path must be absolute or relative to the config location, and the file must be UTF-8 encoded. Each token in the file must be separated by a line break. Either this parameter or
word_listmust be specified. -
hyphenation_patterns_pathstringrequired -
Path to an Apache FOP (Formatting Objects Processor) XML hyphenation pattern file. This path must be absolute or relative to the
configlocation. Only FOP v1.2 compatible files are supported. -
keep_wordsstring[] -
List of words to keep. Only tokens that match words in this list are included in the output. Either this parameter or
keep_words_pathmust be specified. -
keep_words_pathstring -
Path to a file that contains a list of words to keep. Only tokens that match words in this list are included in the output. This path must be absolute or relative to the
configlocation, and the file must be UTF-8 encoded. Each word in the file must be separated by a line break. Either this parameter orkeep_wordsmust be specified. -
ignore_caseboolean -
If
true, matching for thekeywordsandkeywords_pathparameters ignores letter case. Defaults tofalse. -
keywordsunion string | string[] -
Array of keywords. Tokens that match these keywords are not stemmed. This parameter,
keywords_path, orkeywords_patternmust be specified. You cannot specify this parameter andkeywords_pattern. -
keywords_pathstring -
Path to a file that contains a list of keywords. Tokens that match these keywords are not stemmed. This path must be absolute or relative to the
configlocation, and the file must be UTF-8 encoded. Each word in the file must be separated by a line break. This parameter,keywords, orkeywords_patternmust be specified. You cannot specify this parameter andkeywords_pattern. -
filler_tokenstring -
String used in shingles as a replacement for empty positions that do not contain a token. This filler token is only used in shingles, not original unigrams. Defaults to an underscore (
_). -
max_shingle_sizenumber | string -
Maximum number of tokens to concatenate when creating shingles. Defaults to
2. -
min_shingle_sizenumber | string -
Minimum number of tokens to concatenate when creating shingles. Defaults to
2. -
output_unigramsboolean -
If
true, the output includes the original input tokens. Iffalse, the output only includes shingles; the original input tokens are removed. Defaults totrue. -
ignore_caseboolean -
If
true, stop word matching is case insensitive. For example, iftrue, a stop word of the matches and removesThe,THE, orthe. Defaults tofalse. -
remove_trailingboolean -
If
true, the last token of a stream is removed if it’s a stop word. Defaults totrue. -
stopwordsunion oneOf -
Language value, such as
_arabic_or_thai_. Defaults to_english_. -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
lenientboolean -
If
trueignores errors while parsing the synonym rules. It is important to note that only those synonym rules which cannot get parsed are ignored. Defaults to the value of theupdateablesetting. -
synonyms_pathstring -
Used to provide a synonym file. This path must be absolute or relative to the
configlocation. -
synonyms_setunion string | string[] -
Provide one or more synonym sets created through the Synonyms Management APIs. Maximum 100 sets per filter.
-
lenientboolean -
If
trueignores errors while parsing the synonym rules. It is important to note that only those synonym rules which cannot get parsed are ignored. Defaults to the value of theupdateablesetting. -
synonyms_pathstring -
Used to provide a synonym file. This path must be absolute or relative to the
configlocation. -
synonyms_setunion string | string[] -
Provide one or more synonym sets created through the Synonyms Management APIs. Maximum 100 sets per filter.
-
catenate_allboolean -
If
true, the filter produces catenated tokens for chains of alphanumeric characters separated by non-alphabetic delimiters. Defaults tofalse. -
catenate_numbersboolean -
If
true, the filter produces catenated tokens for chains of numeric characters separated by non-alphabetic delimiters. Defaults tofalse. -
catenate_wordsboolean -
If
true, the filter produces catenated tokens for chains of alphabetical characters separated by non-alphabetic delimiters. Defaults tofalse. -
generate_number_partsboolean -
If
true, the filter includes tokens consisting of only numeric characters in the output. Iffalse, the filter excludes these tokens from the output. Defaults totrue. -
generate_word_partsboolean -
If
true, the filter includes tokens consisting of only alphabetical characters in the output. Iffalse, the filter excludes these tokens from the output. Defaults totrue. -
preserve_originalboolean | string -
If
true, the filter includes the original version of any split tokens in the output. This original version includes non-alphanumeric delimiters. Defaults tofalse. -
protected_words_pathstring -
Path to a file that contains a list of tokens the filter won’t split. This path must be absolute or relative to the
configlocation, and the file must be UTF-8 encoded. Each token in the file must be separated by a line break. -
split_on_case_changeboolean -
If
true, the filter splits tokens at letter case transitions. For example: camelCase -> [ camel, Case ]. Defaults totrue. -
split_on_numericsboolean -
If
true, the filter splits tokens at letter-number transitions. For example: j2se -> [ j, 2, se ]. Defaults totrue. -
stem_english_possessiveboolean -
If
true, the filter removes the English possessive ('s) from the end of each token. For example: O'Neil's -> [ O, Neil ]. Defaults totrue. -
type_tablestring[] -
Array of custom type mappings for characters. This allows you to map non-alphanumeric characters as numeric or alphanumeric to avoid splitting on those characters.
-
type_table_pathstring -
Path to a file that contains custom type mappings for characters. This allows you to map non-alphanumeric characters as numeric or alphanumeric to avoid splitting on those characters.
-
catenate_allboolean -
If
true, the filter produces catenated tokens for chains of alphanumeric characters separated by non-alphabetic delimiters. Defaults tofalse. -
catenate_numbersboolean -
If
true, the filter produces catenated tokens for chains of numeric characters separated by non-alphabetic delimiters. Defaults tofalse. -
catenate_wordsboolean -
If
true, the filter produces catenated tokens for chains of alphabetical characters separated by non-alphabetic delimiters. Defaults tofalse. -
generate_number_partsboolean -
If
true, the filter includes tokens consisting of only numeric characters in the output. Iffalse, the filter excludes these tokens from the output. Defaults totrue. -
generate_word_partsboolean -
If
true, the filter includes tokens consisting of only alphabetical characters in the output. Iffalse, the filter excludes these tokens from the output. Defaults totrue. -
preserve_originalboolean | string -
If
true, the filter includes the original version of any split tokens in the output. This original version includes non-alphanumeric delimiters. Defaults tofalse. -
protected_words_pathstring -
Path to a file that contains a list of tokens the filter won’t split. This path must be absolute or relative to the
configlocation, and the file must be UTF-8 encoded. Each token in the file must be separated by a line break. -
split_on_case_changeboolean -
If
true, the filter splits tokens at letter case transitions. For example: camelCase -> [ camel, Case ]. Defaults totrue. -
split_on_numericsboolean -
If
true, the filter splits tokens at letter-number transitions. For example: j2se -> [ j, 2, se ]. Defaults totrue. -
stem_english_possessiveboolean -
If
true, the filter removes the English possessive ('s) from the end of each token. For example: O'Neil's -> [ O, Neil ]. Defaults totrue. -
stopwordsunion oneOf -
Values:
_arabic__armenian__basque__bengali__brazilian__bulgarian__catalan__cjk__czech__danish__dutch__english__estonian__finnish__french__galician__german__greek__hindi__hungarian__indonesian__irish__italian__latvian__lithuanian__norwegian__persian__portuguese__romanian__russian__serbian__sorani__spanish__swedish__thai__turkish__none_ -
max_subword_sizenumber -
Maximum subword character length. Longer subword tokens are excluded from the output. Defaults to
15. -
min_subword_sizenumber -
Minimum subword character length. Shorter subword tokens are excluded from the output. Defaults to
2. -
min_word_sizenumber -
Minimum word character length. Shorter word tokens are excluded from the output. Defaults to
5. -
word_liststring[] -
A list of subwords to look for in the token stream. If found, the subword is included in the token output. Either this parameter or
word_list_pathmust be specified. -
word_list_pathstring -
Path to a file that contains a list of subwords to find in the token stream. If found, the subword is included in the token output. This path must be absolute or relative to the config location, and the file must be UTF-8 encoded. Each token in the file must be separated by a line break. Either this parameter or
word_listmust be specified. -
settingsobject -
Same fields as
settings -
similaritymap string to oneOf -
Configure custom similarity settings to customize how search results are scored.
-
<string>union oneOf -
mappingobject -
Enable or disable dynamic mapping for an index.
-
total_fieldsobject -
limitnumber | string · default: 1000 -
The maximum number of fields in an index. Field and object mappings, as well as field aliases count towards this limit. The limit is in place to prevent mappings and searches from becoming too large. Higher values can lead to performance degradations and memory issues, especially in clusters with a high load or few resources.
-
ignore_dynamic_beyond_limitboolean | string · default: false -
This setting determines what happens when a dynamically mapped field would exceed the total fields limit. When set to false (the default), the index request of the document that tries to add a dynamic field to the mapping will fail with the message Limit of total fields [X] has been exceeded. When set to true, the index request will not fail. Instead, fields that would exceed the limit are not added to the mapping, similar to dynamic: false. The fields that were not added to the mapping will be added to the _ignored field.
-
nested_fieldsobject -
limitnumber · default: 50 -
The maximum number of distinct nested mappings in an index. The nested type should only be used in special cases, when arrays of objects need to be queried independently of each other. To safeguard against poorly designed mappings, this setting limits the number of unique nested types per index.
-
field_name_lengthobject -
limitnumber -
Setting for the maximum length of a field name. This setting isn’t really something that addresses mappings explosion but might still be useful if you want to limit the field length. It usually shouldn’t be necessary to set this setting. The default is okay unless a user starts to add a huge number of fields with really long names. Default is
Long.MAX_VALUE(no limit). -
indexing_pressureobject -
Configure indexing back pressure limits.
-
memoryobjectrequired -
limitnumber -
Number of outstanding bytes that may be consumed by indexing requests. When this limit is reached or exceeded, the node will reject new coordinating and primary operations. When replica operations consume 1.5x this limit, the node will reject new replica operations. Defaults to 10% of the heap.
-
storeobject -
The store module allows you to control how index data is stored and accessed on disk.
-
typeunion anyOf -
Supported values include:
fs: Default file system implementation. This will pick the best implementation depending on the operating environment, which is currently hybridfs on all supported systems but is subject to change.niofs: The NIO FS type stores the shard index on the file system (maps to Lucene NIOFSDirectory) using NIO. It allows multiple threads to read from the same file concurrently. It is not recommended on Windows because of a bug in the SUN Java implementation and disables some optimizations for heap memory usage.mmapfs: The MMap FS type stores the shard index on the file system (maps to Lucene MMapDirectory) by mapping a file into memory (mmap). Memory mapping uses up a portion of the virtual memory address space in your process equal to the size of the file being mapped. Before using this class, be sure you have allowed plenty of virtual address space.hybridfs: The hybridfs type is a hybrid of niofs and mmapfs, which chooses the best file system type for each type of file based on the read access pattern. Currently only the Lucene term dictionary, norms and doc values files are memory mapped. All other files are opened using Lucene NIOFSDirectory. Similarly to mmapfs be sure you have allowed plenty of virtual address space.
-
Values:
fsniofsmmapfshybridfs -
allow_mmapboolean -
You can restrict the use of the mmapfs and the related hybridfs store type via the setting node.store.allow_mmap. This is a boolean setting indicating whether or not memory-mapping is allowed. The default is to allow it. This setting is useful, for example, if you are in an environment where you can not control the ability to create a lot of memory maps so you need disable the ability to use memory-mapping.
type: custom
type: fingerprint
type: nori
type: pattern
type: standard
type: stop
type: icu_analyzer
type: kuromoji
type: snowball
type: arabic
type: armenian
type: basque
type: bengali
type: brazilian
type: bulgarian
type: catalan
type: chinese
type: cjk
type: czech
type: danish
type: dutch
type: english
type: estonian
type: finnish
type: french
type: galician
type: german
type: greek
type: hindi
type: hungarian
type: indonesian
type: irish
type: italian
type: latvian
type: lithuanian
type: norwegian
type: persian
type: portuguese
type: romanian
type: russian
type: serbian
type: sorani
type: spanish
type: swedish
type: turkish
type: thai
type: mapping
type: pattern_replace
type: icu_normalizer
type: asciifolding
type: cjk_bigram
type: common_grams
type: condition
type: delimited_payload
type: edge_ngram
type: elision
type: fingerprint
type: hunspell
type: hyphenation_decompounder
type: keep_types
type: keep
type: keyword_marker
type: length
type: limit
type: lowercase
type: min_hash
type: multiplexer
type: ngram
type: nori_part_of_speech
type: pattern_capture
type: pattern_replace
type: predicate_token_filter
type: scandinavian_normalization
type: shingle
type: snowball
type: stemmer_override
type: stop
type: synonym_graph
type: synonym
type: truncate
type: unique
type: word_delimiter_graph
type: word_delimiter
type: ja_stop
type: kuromoji_stemmer
type: kuromoji_readingform
type: kuromoji_part_of_speech
type: icu_collation
type: icu_folding
type: icu_normalizer
type: icu_transform
type: phonetic
type: dictionary_decompounder
type: DFI
type: DFR
type: IB